--Meta Knight forces PF_THOKKED so we gotta account for that here.
--This is gonna be hardcoded for MetaKnight only cause this will
--go against the design of other characters due to how it's implemented.

--If you know other characters that need this then lmk in my adodn
--discussion thread.

--Single command for Meta Knight exclusively
local allowMKShields = CV_RegisterVar({
	name = "shield4all_metaknightshields",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
})


local function FixPfThokked()
	if allowMKShields.value == 0 then
		return
	end
	
	for p in players.iterate do
		if not p or not p.valid or not p.mo or not p.mo.valid or p.mo.skin ~= "metaknight" then
			continue
		elseif (p.powers[pw_shield] < SH_WHIRLWIND) or (p.powers[pw_shield] == SH_PITY)
		or (p.powers[pw_shield] == SH_FIREFLOWER) then
			continue --user has no shield with an ability, or is holding the button down
		end
		
		--Making a player variable to track shield usage.
		if p.shield4all_metaShield == nil then
			p.shield4all_metaShield = false --give everyone this variable if they are MK
			p.shield4all_metaWater = false --This is for water shenanigans with water.
			p.shield4all_metaShine = false --This is to stop MetaKnight from constantly damaging enemies with a shield
		end
		
		if P_IsObjectOnGround(p.mo) and not p.shield4all_metaShield then
			p.shield4all_metaShield = true
		elseif (p.cmd.buttons & BT_SHIELD) and p.shield4all_metaShield
		and not p.shield4all_metaShine then
			p.pflags = $ & ~PF_THOKKED --This allows MK to use shield abilities.
			if not (p.pflags & PF_JUMPED) then --only apply jumped if MK does not already have it
				p.pflags = $ | PF_JUMPED
				p.shield4all_metaWater = true --this lets us immediately turn off jumped.
			end
			p.shield4all_metaShield = false --This stops him from using it more than once.
			p.shield4all_metaShine = true
		end
	end
end

local function JumpedHandler()
	if allowMKShields.value == 0 then
		return
	end
	
	for p in players.iterate do
		if not p or not p.valid or not p.mo or not p.mo.valid or p.mo.skin ~= "metaknight" then
			continue
		end
		
		--This will only run if MetaKnight uses a shield ability without PF_JUMPED
		if p.shield4all_metaWater == true then
			p.pflags = $ & ~PF_JUMPED
			p.shield4all_metaWater = false
		end
		
		--This will only run when the shield button is released
		if not (p.cmd.buttons & BT_SHIELD) and p.shield4all_metaShine == true then
			p.shield4all_metaShine = false
		end
	end
end

--runs the main function every tic
addHook("PreThinkFrame", FixPfThokked)

addHook("ThinkFrame", JumpedHandler)