--Pikaspoop here, this addon is open assets!

--This console variable determines if the list is a whitelist or a blacklist.
local isWhitelist = CV_RegisterVar({
	name = "shield4all_whitelistmode",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
})

--this table will hold every skin name that will be checked
local skinList = {
}


--Basic function to print the command instructions
local function printInstruct(p)
	CONS_Printf(p, "===================")
	CONS_Printf(p, "shieldtoggle_toggleskin <Internal skin name>")
	CONS_Printf(p, "")
	CONS_Printf(p, "Adds a skin to the shield list if valid.")
	CONS_Printf(p, "===================")
end


--This function handles the command to add skins to the whitelist/blacklist
local function AddSkinToList(p, arg)
	if arg ~= nil then
		arg = string.lower(arg)		
		if skins[arg] ~= nil then
			if skinList[arg] then
				skinList[arg] = nil --skin exists, remove it
				CONS_Printf(p, "The skin has been removed from the list.")
			else
				skinList[arg] = true
				CONS_Printf(p, "The skin has been added to the list.")
			end
		else
			printInstruct(p)
		end
	else
		printInstruct(p)
	end
end


local function ApplyShieldButton()
	for p in players.iterate do
		if not p or not p.valid or not p.mo or not p.mo.valid then
			continue --Skip players that are not valid
		elseif (skinList[p.mo.skin] and isWhitelist.value == 0) or (not skinList[p.mo.skin] and isWhitelist.value == 1) then
		if not (p.charflags & SF_NOSHIELDABILITY) then
				p.charflags = $ | SF_NOSHIELDABILITY --Values match, apply the flag
			end
		else
			if (p.charflags & SF_NOSHIELDABILITY) then
				p.charflags = $ & ~SF_NOSHIELDABILITY --values do not match, remove the flag.
			end
		end
	end
end

--Adds the command to toggle a skin being given shield abilities or not
COM_AddCommand("shield4all_toggleskin", AddSkinToList, COM_ADMIN)


--runs the main function every tic
addHook("ThinkFrame", ApplyShieldButton)


--this hook keeps our table variable synced in netgames
--The whitelist cvar is already defined as a netvar, no need to include it here
addHook("NetVars", function(network)
	skinList = network(skinList)
end)