--Thanks to Lach (aka lackablock) for teaching me the basics of how to
--overload functions built into the game, and for the code used to
--assign the rawset.

--Another Table, allows players to specify characters that use
--ShieldSpecial to stop shield abilities.

local shspecTable = {}


--Basic function to print the command instructions
local function printInstruct(p)
	CONS_Printf(p, "===================")
	CONS_Printf(p, "shieldtoggle_ancientSkin <Internal skin name>")
	CONS_Printf(p, "")
	CONS_Printf(p, "Adds a skin to the shieldSpecial list if valid.")
	CONS_Printf(p, "This is meant for older skins that rely on the")
	CONS_Printf(p, "SpinSpecial hook to stop shields.")
	CONS_Printf(p, "")
	CONS_Printf(p, "This can break characters who do more with SpinSpecial.")
	CONS_Printf(p, "===================")
end


--This function handles the command to add skins to the spinspecial list
local function AddSkinToList(p, arg)
	if arg ~= nil then
		arg = string.lower(arg)		
		if skins[arg] ~= nil then
			if shspecTable[arg] then
				shspecTable[arg] = nil --skin exists, remove it
				CONS_Printf(p, "The skin has been removed from the list.")
			else
				shspecTable[arg] = true
				CONS_Printf(p, "The skin has been added to the list.")
			end
		else
			printInstruct(p)
		end
	else
		printInstruct(p)
	end
end


--Adds the command to toggle a skin being given shield abilities or not
COM_AddCommand("shield4all_shieldspecialfix", AddSkinToList, COM_ADMIN)



--Now we fix characters who use ShieldSpecial
--This is how we access the real addHook after overloading it
local addHookRef = addHook

--Thank you Lach!!!!
rawset(_G, "addHook", function(hookType, hookFunction, ...)
    if hookType == "ShieldSpecial" then
        addHookRef(hookType, function(p, ...)
            if shspecTable[p.mo.skin] then
                return
            end
            return hookFunction(p, ...)
        end, ...)
    else
        return addHookRef(hookType, hookFunction, ...)
    end
end)



--this hook keeps our table variable synced in netgames
addHook("NetVars", function(network)
	shspecTable = network(shspecTable)
end)